﻿// mainframe.as
/*
  Тут часть кода, работающая с основным окном
*/
void initMainFrameWork()
{
    getEventService().subscribe(eventCreateFrame, AStoIUnknown(EventTopLevelFrame(), IID_IEventRecipient));
}

ITopLevelFrame@ mainFrame;
ITopLevelFrame@ coreMainFrame;

class EventTopLevelFrame {
    void onEvent(const Guid&in eventID, long val, IUnknown& obj)
    {
        debugger();
        ITopLevelFrame@ frame = obj;
        if (frame !is null) {
            if (mainFrame is null) {
                if (frame.frameType() == eTLFT_Main) {
                    @mainFrame = frame;
                    mainFrame.getCoreTopLevelFrame(coreMainFrame);
                    trMainFrame_setTitle.setTrap(coreMainFrame, ITopLevelFrame_setTitle, MainFrame_setTitle);
                    trMainFrame_setAddTitle.setTrap(coreMainFrame, ITopLevelFrame_setAdditionalTitle, MainFrame_setAdditionalTitle);
                }
            }
        }
    }
};

TrapVirtualStdCall trMainFrame_setTitle;
TrapVirtualStdCall trMainFrame_setAddTitle;

void MainFrame_setTitle(ITopLevelFrame&frame, const v8string&in str)
{
    //Message("Set title " + str);
    setCaption(string(str), string(frame.getAdditionalTitle()));
}

void MainFrame_setAdditionalTitle(ITopLevelFrame&frame, const v8string&in str)
{
    //Message("Set addtitle " + str);
    setCaption(string(frame.getTitle()), string(str));
}

void setCaption(const string& title, const string& additionalTitle)
{
    v8string ibName;
    IProfileFolder@ root = getProfileRoot();
    root.getString("CmdLine/IBName", ibName);
    string caption = string(ibName) + " / " + title.dup().replace("Конфигуратор - ", "");
    if (!additionalTitle.isEmpty())
        caption += " - " + additionalTitle;
    IWindow@ wnd = cast<IUnknown>(mainFrame);
    if (wnd !is null)
        SetWindowText(wnd.hwnd(), caption.c_str());
}